﻿using System;
using UnityEngine;
using System.Collections;
using System.Runtime.InteropServices;

public class AndroidDeepLink : MonoBehaviour
{
    private static object lockObject = new object();

    public static string GetURL()
    {
        string result = "null";
#if UNITY_ANDROID
        lock (lockObject)
        {
            try
            {
                using (AndroidJavaClass jclass = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
                {
                    AndroidJavaObject activity = jclass.GetStatic<AndroidJavaObject>("currentActivity");
                    result = activity.Call<string>("ReturnURL");
                    
                    return result;
                }
            }
            catch (System.Exception ex)
            {
                Debug.LogWarning("SystemException 1");
                Debug.LogWarning(ex.Message);
                result = "null";
                return result;
            }
        }
#endif
#if !UNITY_ANDROID
            return result;
#endif
    }

    public static void ResetURL()
    {
#if UNITY_ANDROID
        lock (lockObject)
        {

            try
            {
                using (AndroidJavaClass jclass = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
                {
                    AndroidJavaObject activity = jclass.GetStatic<AndroidJavaObject>("currentActivity");
                    Debug.Log("Reset Deeplink");
                    activity.Call("ResetURL");
                }
            }
            catch (System.Exception ex)
            {
                Debug.LogWarning("SystemException 2");
                Debug.LogWarning(ex.Message);
            }
        }
#endif
    }
}
